Subject: Re: Caching Problem with 1.0 and a Proxy Server

From: Dave Kristol <[email-masked]>
Date: Wed, 8 Nov 2000 09:20:05 -0500 (EST)

"Tim Coates" <[email-masked]> wrote:
  > A small problem to overcome...
  > 
  > We already know the caching problems with 1.0 but....
  > 
  > Firstly, assume that no proxy server is used. A browser send a a request
  > using HTTP 1.1 protocol. The response it receives from the web server is
  > also HTTP 1.1. This can be proven viewing the logs provided by a packet
  > sniffer. The document received by the browser contains 1.1 header for cache
  > control. The cache control instructions basically force the brower to do a
  > get each time the user requests the page.
  > 
  > Now... add a proxy server. I had to modify the Windows registry so that the
  > browser would issue a 1.1 request to the web server (via the proxy). The
  > browser sends a 1.1 request, but receives a 1.0 response - this is from the
  > same web server, and I am using the same browser.
  > 
  > What appears to happen is that the proxy server downgrades the protocol
  > identifier (at least in the response back to the web browser) and forwards
  > the response containing the 1.1 cache control headers to the browser. The
  > browser now interprets the response using the 1.0 instructions and the end
  > result is that the page is caches. If I ask for the same page again (and not
  > using a forced GET) the page is retrieved from the cache as no GET request
  > is captured by the packet sniffer.

Do you know whether the proxy server is a *1.1* proxy?  More than
likely it is not.  Therefore the proxy won't know about HTTP/1.1, will
send requests as HTTP/1.0 requests because it doesn't know better, and
treat responses accordingly.  And that is why, as Jeff Mogul has already
remarked, the browser should be cautious about how it interprets

Dave Kristol
HTTP/1.1 headers.